/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package jsfbeans;

import entities.CompteBancaire;
import java.io.Serializable;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import javax.ejb.EJB;
import javax.inject.Named;
import javax.faces.view.ViewScoped;
import sessions.GestionnaireCompteBancaire;

/**
 *
 * @author mbuffa
 */
@Named(value = "compteMBean")
@ViewScoped
public class CompteMBean implements Serializable {

    @EJB
    GestionnaireCompteBancaire g;

    private List<CompteBancaire> listesComptes;
    private double montant;
    private int idCompteDeDepot;

    // Modeles / propriétés pour le transfert
    int id1;
    int id2;
    double montantTransfert;

    public int getId1() {
        return id1;
    }

    public void setId1(int id1) {
        this.id1 = id1;
    }

    public int getId2() {
        return id2;
    }

    public void setId2(int id2) {
        this.id2 = id2;
    }

    public double getMontantTransfert() {
        return montantTransfert;
    }

    public void setMontantTransfert(double montantTransfert) {
        this.montantTransfert = montantTransfert;
    }

    public List<CompteBancaire> getListesComptes() {
        return listesComptes;
    }

    public void setListesComptes(List<CompteBancaire> listesComptes) {
        this.listesComptes = listesComptes;
    }

    public int getIdCompteDeDepot() {
        return idCompteDeDepot;
    }

    public void setIdCompteDeDepot(int idCompteDeDepot) {
        this.idCompteDeDepot = idCompteDeDepot;
    }

    public double getMontant() {
        return montant;
    }

    public void setMontant(double montant) {
        this.montant = montant;
    }

    public String getDate() {
        Calendar rightNow = Calendar.getInstance();
        int hour = rightNow.get(Calendar.HOUR_OF_DAY);
        int minute = rightNow.get(Calendar.MINUTE);
        int second = rightNow.get(Calendar.SECOND);
        String dString = "" + 
               hour + ":" + minute + ":"
                + second;
        return dString;
    }

    /**
     * Creates a new instance of CompteMBean
     */
    public CompteMBean() {
    }

    public List<CompteBancaire> getComptesBancaires() {
        System.out.println("DANS GET COMPTE BANCAIRE");
        if (listesComptes == null) {
            rafraichirLesDonnees();
        }
        return listesComptes;
    }

    public void rafraichirLesDonnees() {
        System.out.println("ON FAIT LE SELECT *");
        listesComptes = g.getAllComptesBancaires();
    }

    // ---- ACTIONS
    public void deposerArgent() {
        g.deposeArgent(idCompteDeDepot, montant);
        // rafraichir les données à afficher
        rafraichirLesDonnees();
    }

    public void retireArgent() {
        g.retireArgent(idCompteDeDepot, montant);
        rafraichirLesDonnees();
    }

    public void transfert() {
        // MAL MAL MAL MAL OUILLE AILLLE NON JAMAIS ARGL !!!!!
        //g.retireArgent(id1, montantTransfert);
        //g.deposeArgent(id2, montantTransfert);
        
        // CA C'EST BON MIAM !!!!
        g.transfert(id1, id2, montantTransfert);
        rafraichirLesDonnees();
    }
}
